<?php
// 02.05.2020 copyright Klaus Eisert
include "_init.php";

Global $becho;  //1:website, 2:file
Global $k8db;

Global $navigation;
Global $gdatareadlimitpage;
Global $datadefinitions;

$GLOBALS['clientID']=0;
$GLOBALS['gdatareadlimit']=50;
$GLOBALS['numericTypesAll'] = array("TINYINT","SMALLINT","MEDIUMINT","BIGINT","INT","FLOAT","DOUBLE","DECIMAL");

$GLOBALS['generalformat']=0;
$GLOBALS['thousands_sep']=',';
$GLOBALS['decimal_point']='.';
$GLOBALS['generaldateformat']='m/d/Y';
$GLOBALS['sqldateformat']='%m/%d/%Y';
$GLOBALS['tabulatordateformat']='DD/MM/YYYY';
$GLOBALS['tabulator_datetime_fp']=json_encode(array('inputFormat'=>'YYYY-MM-DD','outputFormat'=>$GLOBALS['tabulatordateformat']));

$GLOBALS['langclass']=new languagesupport($domain_language);
$GLOBALS['langmodule']='';

define('CONST_DATAREAD',1);

// ----------------------------- locale  --------------------------------------
mylocale($domain_language);

function mylocale($browserLocale=''){
    if(gbnull($browserLocale)){
      $browserLocale = substr($_SERVER['HTTP_ACCEPT_LANGUAGE'], 0, 2);
    }
    //echo 'CONST_DATAREAD='.CONST_DATAREAD.'<br>';
    /*
    if(isset($_SESSION)){
      if(getfromArray($_SESSION,'username')==='merkel'){
          $browserLocale='de';
      }
    }*/
    
    setlocale(LC_ALL,$browserLocale);
    $GLOBALS['thousands_sep']=localeconv()['thousands_sep'];
    $GLOBALS['decimal_point']=localeconv()['decimal_point'];
    if(instr(',de,at,ch,',$browserLocale)>-1){
        $GLOBALS['generaldateformat']='d.m.Y';
        $GLOBALS['tabulatordateformat']='DD.MM.YYYY';
        $GLOBALS['tabulator_datetime_fp']=json_encode(array('inputFormat'=>'YYYY-MM-DD','outputFormat'=>$GLOBALS['tabulatordateformat']));
        $GLOBALS['sqldateformat']='%d.%m.%Y';
    }
    if(0){
        echo '<pre>';
        print_r(localeconv());
        echo '</pre>';
        echo 'tabulatordateformat='.$GLOBALS['tabulatordateformat'];
    }
}

/* ----------------------------------- datadefinitions ---------------------------- */
//include('datadefinitions.php');

/* ----------------------------------- controll the structure ---------------------------- 
$becho=false;
if($becho){
    $datadefID=2;
    $dbclass=new dbclass();
    $datadefinitions[2]['columns']=$dbclass->ShowTable($datadefinitions[$datadefID]['table'],$datadefinitions[$datadefID]['key']);

    echo "hier<br>";
    echo '<pre>';

    print_r(table2colobject($datadefinitions[$datadefID]['columns']));

    //print_r(json_decode($temp));
    //print_r($datadefinitions[2]);
    //print_r($datadefinitions[1]['columns']);
    //print_r($datadefinitions[2]['tabulator']['columns']);
    //print_r($datadefinitions[1]['jsonform']['schema']);
    echo '</pre>';
}*/

class dbclass{
    public $db;
    public $error;
    public $clientID;

    public function __construct(){
        $this->error='';
        $this->clientID=getfromarray($_SESSION,'clientID',0);
        if(isset($GLOBALS['k8db'])){
            $this->db=$GLOBALS['k8db'];
        }else{
            include('_mysql.php');
            /*echo '$server='.$server.'<br>';
            echo '$username='.$username.'<br>';
            echo '$password='.$password.'<br>';
            echo '$database='.$database.'<br>';*/
            try{
                $this->db=@mysqli_connect($server, $username, $password, $database);
                //$this->db=new mysqli($server, $username, $password, $database);
            }catch(Throwable $e){ 
                // nothing
            }
            //if ($this->db->connect_errno){
            if(mysqli_connect_errno()){
                $this->error="no database connection!<br>set your database connection in \"_mysql.php\"";
                //$this->error=mysqli_connect_errno();
            }else{
                //echo 'clientID: '.$this->clientID."<BR>";
                $this->db->query("SET NAMES 'utf8'");                
                $GLOBALS['k8db']=$this->db;
            }
        }
    }

    public function ShowTable($table,&$keycolumn){
        // Sample
        // fieldname  | mytype   | mynull| mykey | mydefault | myextra        |
        // Field      | Type     | Null  | Key   | Default   | Extra          |
        // Id         | int(11)  | NO    | PRI   | NULL      | auto_increment |        
            
        $this->error="";
        $result=array();
        $sql="DESCRIBE ".$table;
        $query=$this->db->query($sql);
        if ($query) {
            while($row=$query->fetch_array(MYSQLI_ASSOC)){
                $posstart=instr($row['Type'],'(');
                if($posstart>=0){
                    $posende=instr($row['Type'],')');
                    $row['mytype']=strtoupper(substr($row['Type'],0,$posstart));
                    $row['size']=intval(substr($row['Type'],$posstart+1,$posende-$posstart-1));
                }else{
                    $row['mytype']=strtoupper($row['Type']);
                    $row['size']=0;
                }
                if($row['Key']=='PRI'){
                    if(gbnull($keycolumn)){
                        $keycolumn=$row['Field'];
                    }else{
                        //$this->error="Primary Key has >1 columns!";
                    }
                }
                $row['fieldname']=$row['Field'];
                $row['mynull']=$row['Null'];
                $row['mykey']=$row['Key'];
                $row['mydefault']=$row['Default'];
                $row['myextra']=$row['Extra'];
                $result[]=$row;
                //echo $row['fieldname'].' '.$row['Key'].'<br>';
            }
            return $result;
        }else{
            $this->error="(" .$this->db->errno.") ".$this->db->error;
        }
        return 0;
    }    

    public function ShowTables(){
        $result=array();
        $sql="show tables";
        $query=$this->db->query($sql);
        if ($query) {
            while($record=$query->fetch_array()){
                $result[]=$record[0];
            }
        }
        return $result;
    }

    public function bexist($table, $clause) {
        $result=false;
        $sql="SELECT '' as field FROM " . $table;

        if(strpos($clause,"§clientID")!==false){
            $clause=str_replace("§clientID","clientID=$this->clientID",$clause);
        }
        
        if ($clause!='') {
            $sql=$sql . " WHERE " . $clause;
        }
        if(getfromarray($_SESSION,'developper',0)){echo htmlspecialchars($sql) . '<br>';}
        //echo 'bexist.sql='.htmlspecialchars($sql) . '<br>';
        
        $records=$this->db->query($sql);
        if($records){
            $dat=$records->fetch_array();
            if($dat){
                $result=true;
            }
        }else{
            $this->error="(" .$this->db->errno.") ".$this->db->error;
            //echo $this->error;
        }
        return $result;
    }
    
    public function lookup($field, $table, $clause, $default='',$orderby='',$limit='') {
        //if($table=='addresses'){
            //and instr('login') )
        //}
        //if(getfromarray($_SESSION,"superuser",0)>=1)
        $sql="SELECT " . $field . " FROM " . $table;
        
        if ($clause!='') {
            $sql=$sql . " WHERE " . $clause;
        }
        if (!gbnull($orderby)) {
            $sql=$sql." ORDER BY ".$orderby;
        }
        if(gbnull($limit)){
            $sql=$sql." LIMIT 1 ";
        }else{
            $sql=$sql." ".$limit;
        }
        
        if(instr($sql,"§clientID")<0){
            //$this->error="clientID berücksichtigen!";
            //return false;
        }else{
            $sql=str_replace("§clientID","clientID=$this->clientID",$sql);
        }

        if(getfromarray($_SESSION,"developper",0)){echo htmlspecialchars($sql) . '<br>';}
        //if(1){echo htmlspecialchars($sql) . '<br>';}
        //echo htmlspecialchars($sql) . '<br>';
        
        $pos=strpos($field,' as ');
        if($pos!==false){
            $field=substr($field,$pos+strlen(' as '));
        }
        $result=$this->db->query($sql);
        if($result){
            $row=$result->fetch_array();
            if($row){
                //echo '$field='.$field.' value='.$row[$field].'<br>';
                return $row[$field];
            }else{
                return $default;
            }
        }else{
            $this->error="(" .$this->db->errno.") ".$this->db->error;
            //echo $this->error;
        }
    }

    public function expression($exp, $table, $clause='', $default='', $ifnull='') {
        if(gbnull($ifnull)){
            $sql="SELECT $exp as result FROM " . $table;
        }else{
            $sql="SELECT ifnull($exp,$ifnull) as result FROM " . $table;
        }
        if ($clause!='') {
            $sql=$sql . " WHERE " . $clause;
        }
        if(strpos($sql,"§clientID")==0){
            //$this->error="clientID berücksichtigen!";
            //return false;
        }else{
            $sql=str_replace("§clientID","clientID=$this->clientID",$sql);
        }

        if(getfromarray($_SESSION,'developper',0)){echo htmlspecialchars($sql) . '<br>';}
        //echo htmlspecialchars($sql) . '<br>';
        
        $result=$this->db->query($sql);
        if($result){
            //echo 'ergebnis<br>';
            $row=$result->fetch_array();
            if($row){
                //echo 'zeile[result]='.$row["result"].'<br>';
                return $row["result"];
            }else{
                //echo 'no zeile<br>';
                return $default;
            }
        }else{
            //echo 'no ergebnis<br>';
            if(gbnull($this->db->error)){
                return $default;
            }else{
                $this->error="(" .$this->db->errno.") ".$this->db->error.'<br>';
                //echo $this->error;
            }
        }
    }
    
    public function getentries($sql,$clientID=-1){
        $data=[];
        if(strpos($sql,"§clientID")!==false){
            if($clientID==-1)$clientID=$this->clientID;
            $sql=str_replace("§clientID","clientID=$clientID",$sql);
        }
        //echo "sql=".htmlspecialchars($sql).'<br>';
        $records=$this->db->query($sql);
        if($records){
            while($record=$records->fetch_array(MYSQLI_ASSOC)){
                $data[]=$record;
            }
        }
        return $data;
    }

    function buildSqlInsertFromInput($columns,$postfields,&$sqlfields,&$sqlvalues){
        // requires public for fieldlist,fieldsnum,db
        foreach($postfields as $col=>$v) {
            if (isset($columns[$col]) and strpos($sqlfields,", ".$col.",")===false){
              if(!getfromarray($columns[$col],'noinsert',0)){
                $sqlfields=$sqlfields . "$col, ";
                if(table2jsonformtype($columns[$col]['mytype'])=='number') {
                    if  ($v==''){
                        $v=0;
                    }
                }
                $sqlvalues=$sqlvalues."'".$this->db->real_escape_string($v)."', ";
              }
            }
        }
    }
    
    function buildSqlUpdateFromInput($columns,$postfields,$mode=0){
        // mode: 0=loop postfields, 1=loop fieldlist
        // requires public for fieldlist,db
        $sql='';
        if($mode==0){
            foreach($postfields as $col=>$v){
                if(isset($columns[$col])){
                  if(!getfromarray($columns[$col],'noupdate',0)){
                    $sql.="$col='".$this->db->real_escape_string($v)."', ";
                  }
                }
            }
        }else{
            foreach($columns as $column){
              if(!getfromarray($columns[$col],'noupdate',0)){
                if(isset($postfields[$column])){
                    $sql.="$column='".$this->db->real_escape_string($postfields[$column])."', ";
                }
              }
            }
        }
        return substr($sql,0,-2);
    }

    function bRecordReadPermission($in,&$out){
      $method=$in['method'];
      //$clause=$in['clause'];
      $table=$in['table'];
      $berror=getFromArray($in,'berror',0);
      
      $out['clause']='';
      $out['join']='';
      
      if($method==0){
        $out['clause']='1=2';
        if($berror)$this->error='no rights!';
      }elseif($method==1){
        //check client
        //$out['clause']=gsclauseand($clause,'clientID='.getfromarray($_SESSION,'clientID',0));
        $out['clause']=$table.'.clientID='.getfromarray($_SESSION,'clientID',0);
      }elseif($method==2){
        //$bok=1;
        $out['clause']='1=1';
      }elseif($method==3){
        if(getFromArray($_SESSION,'userID'==0)){
          $out['clause']='1=2';
          if($berror)$this->error='no rights, please login';
        }else{
          $out['clause']='1=1';
        }
      }elseif($method==10){ // check creatorID
          //$out['clause']=gsclauseand($clause,$table.'.creatorID='.getfromarray($_SESSION,'userID',0));
          $out['clause']=$table.'.creatorID='.getfromarray($_SESSION,'userID',0);
      }elseif($method==11){ // check friendID
          $out['clause']="EXISTS(SELECT 1 from k8loginfriends  WHERE ".$table.".creatorID=k8loginfriends.userID and k8loginfriends.friendID=".getFromArray($_SESSION,'userID',0).')';
      }
      return true;
    }

    function bRecordUDPermission($in,&$out){
      // for getentries to get the rights: update and delete
      $method=$in['method'];
      $access=$in['access'];
      $table=$in['table'].'.';
      $out['select']='';
      //echo '$method='.$method.'<br>';
      if($method==0){
        //$out['select']='0 as rightuser_'.$access;
        $out['select']='0 ';
      }elseif($method==1){
        //check client
        //$out['select']='('.$table.'clientID='.getFromArray($_SESSION,'clientID',0).') as rightuser_'.$access;
        $out['select']='('.$table.'clientID='.getFromArray($_SESSION,'clientID',0).') ';
      }elseif($method==2){
        //$out['select']='1 as rightuser_'.$access;
        $out['select']='1 ';
      }elseif($method==3){
        $value=gbnull(getFromArray($_SESSION,'userID',0));
        //$out['select']=$value.' as rightuser_'.$access;
        $out['select']=$value.' ';
      }elseif($method==10){
        //$out['select']='('.$table.'creatorID='.getFromArray($_SESSION,'userID',0).') as rightuser_'.$access;
        $out['select']='('.$table.'creatorID='.getFromArray($_SESSION,'userID',0).') ';
      }elseif($method==11){
        // friendID, no right
      }
    }
    
    function bRecordAccess($in){
      // return brecordaccess
      if(0){
        echo '<pre>';
        print_r($in);
        echo '</pre>';
      }
      $bok=0;
      $method=$in['method'];
      $clause=getfromarray($in,'clause');
      $table=getfromarray($in,'table');
      if($method==0){
        $this->error='no rights!';
      }elseif($method==1){
        //check client
        $clause=gsclauseand($clause,'clientID='.getfromarray($_SESSION,'clientID',0));
        $bok=$this->bexist($table,$clause);
        if(!$bok){
          //!!$this->error=$langclass->getlangValue("system","no rights");
          $this->error='no rights!';
        }
      }elseif($method==2){
        $bok=1;
      }elseif($method==3){
        $bok=getFromArray($_SESSION,'userID'<>0);
      }elseif($method==10){ // check creatorID
          $clause=gsclauseand($clause,'creatorID<>0 and creatorID='.getfromarray($_SESSION,'userID',0));
          $bok=$this->bexist($table,$clause);
          if(!$bok){
            $this->error='no rights!';
          }
          
      }elseif($method==11){ // friends
        $from=$table.' INNER JOIN k8loginfriends ON '.$table.'.creatorID=k8loginfriends.userID';
        $clause=gsclauseand($clause,'k8loginfriends.friendID<>0 and k8loginfriends.friendID='.getfromarray($_SESSION,'userID',0));
        $bok=$this->db_class->bexist($from,$clause);
        if(!$bok){
          $this->error='no rights!';
        }
      }else{
        $this->error='permission method not valid!';
      }
      return $bok;
    }
}

class languagesupport{
	private $language = array ();
    private $mylanguage;
	public $dbclass;
    public $loadedmodules; // string
    private $bexmark;
    private $mode;  // 0=deaktiviert, 1=aktiviert mit "!", 2=aktiviert ohne "!"
        
	public function __construct($language=0){
    }
        
	public function getlangValue($module, $key, $echo = false, $button = false){
      return $key;
    }
}

function customError($errno, $errstr) {
    echo "<b>Error:</b> [$errno] $errstr<br>";
    echo "Ending Script";
    die();
  } 

function table2colobject($cols){
    Global $becho;
    /* 
    {
    ID:
        {fieldname:"ID", ...,
        },
    description:
        {fieldname:"description", ...,
        },
    }
    */
    $columns=array();
    if($cols){
      foreach($cols as $k=>$col){
        if($becho){
        //echo '<br>';
        //var_dump($col);
        //echo $col.'<br>';
        }
        /*
        if(instr(',clientID,creatorID,datecreated,datetimecreated',','.$col['fieldname'].',')===-1){
            $columns[$col['fieldname']]=$col;
        }
        */
        if(!isset($col['noupdate'])){
          $col['noupdate']=0;
          if(getFromArray($col,'Extra')=='auto_increment' or instr(',clientID,creatorID,datecreated,datetimecreated',','.$col['fieldname'].',')>-1){
            $col['noupdate']=1;
          }
        }
        if(!isset($col['noinsert'])){
          $col['noinsert']=0;
          if(getFromArray($col,'Extra')=='auto_increment' or instr(',clientID,creatorID,datecreated,datetimecreated',','.$col['fieldname'].',')>-1){
            $col['noinsert']=1;
          }
        }
        $columns[$col['fieldname']]=$col;
      }
    }
    return $columns;
}

function table2tabulator($cols){
    Global $becho;
    // 	columns:[ //Define Table Columns
	// 	{title:"Name", field:"name", width:150, headerFilter:true, headerFilterLiveFilter:false,cssClass:"test"},
	// 	{title:"Age", field:"age", align:"left", formatter:"progress"},
	// 	{title:"Favourite Color", field:"col", headerFilter:true},
	// 	{title:"Date Of Birth", field:"dob", sorter:"date", align:"center",headerFilter:true},
 	//],
    $columns=array();
    $colmax=8;
    $i=0;
    if($cols){
      foreach($cols as $k=>$col){
          if($becho){
          //echo '<br>';
          //var_dump($col);
          //echo $col.'<br>';
          }
          if(instr(',clientID,creatorID,datecreated,datetimecreated',','.$col['fieldname'].',')===-1){
              $mytype=getfromArray($col,'mytype');
              $dat=array();
              if(getFromArray($col,'myextra')=='auto_increment'){
                  // dont display
              }else{
                  $title=(gbnull(getfromArray($col,'label'))? $col['fieldname'] : $col['label']);
                  $dat=array('title'=>$title,'field'=>$col['fieldname'],'headerFilter'=>true);
                  if(is_tablefieldnumeric($col['mytype'])){
                      $dat['align']='right';
                      $dat['width']='80';
                      if(getfromArray($col,'decimals',0)>0){
                          $dat['formatter']='money';
                          $dat['formatterParams']=array('decimal'=>$GLOBALS['decimal_point'],'thousand'=>$GLOBALS['thousands_sep'],'precision'=>$col['decimals']);
                      }
                  }elseif(instr($mytype,'CHAR')>=0 and !gbnull(getfromArray($col,'size'))){
                      $width=getfromArray($col,'size')*10;
                      if($width>250)$width=250;
                      //$dat['width']=$width;
                  }elseif($mytype=='DATE'){
                      $dat['width']=120;
                      $dat['formatter']='datetime';
                      $dat['formatterParams']=array('inputFormat'=>'YYYY-MM-DD','outputFormat'=>$GLOBALS['tabulatordateformat']);
                  }elseif($mytype=='TIME'){
                      $dat['width']=70;
                  }elseif($mytype=='DATETIME'){
                      $dat['width']=160;
                  }
                  $columns[]=$dat;
                  $i++;
              }
              if($colmax>0 and $i>$colmax)break;
          }
      }
    }
    return $columns;
}

function table2jsonform($cols){
    /* $cols:
    fieldname, mytype are obligatory!
    
    retruns object structure:
    schema:{
        name: {
            type: 'string',
            title: 'Name',
            required: true
        }
    }
    */
    $schema=array();
    $jsontype="";
    if($cols){
      foreach($cols as $k=>$col){
          if(instr(',clientID,creatorID,datecreated,datetimecreated',','.$col['fieldname'].',')===-1){
              $mytype=getfromArray($col,'mytype');
              if(getfromArray($col,'fieldtype',0)==1 or getFromArray($col,'myextra')=='auto_increment'){
                  $jsontype='hidden';
              }else{
                  $jsontype=table2jsonformtype($col['mytype']);
              }
              $schema[$col['fieldname']]=array('type'=>$jsontype);
              if(gbnull(getfromArray($col,'label'))){
                  $schema[$col['fieldname']]['title']=$col['fieldname'];
              }else{
                  $schema[$col['fieldname']]['title']=$col['label'];
              }
              //echo instr(getfromArray($col,'mytype'),'CHAR').' / '.getfromArray($col,'size').'<br>';
              if(instr($mytype,'CHAR')>=0 and !gbnull(getfromArray($col,'size'))){
                  $schema[$col['fieldname']]['maxLength']=$col['size'];
              }
              if(getfromArray($col,'decimals',0)>0)$schema[$col['fieldname']]['step']='0.'.str_repeat('0',$col['decimals']-1).'1';
              if(getfromArray($col,'required',false)) $schema[$col['fieldname']]['required']=true;
          }
      }
    }
    return $schema;
}

function is_tablefieldnumeric($mytype){
    $arr=explode('(',$mytype);
    $t='';
    if(isset($arr[0])){
        $t=strtoupper($arr[0]);
    }else{
        $t=strtoupper($mytype);
    }
    return (in_array($t,$GLOBALS['numericTypesAll']));
}
function tablefieldtype($mytype){
    $arr=explode('(',$mytype);
    $t='';
    if(isset($arr[0])){
        $t=strtoupper($arr[0]);
    }else{
        $t=strtoupper($mytype);
    }
    return $t;
}

function table2jsonformtype($mytype){
    /*
    $arr=explode('(',$mytype);
    $t='';
    if(isset($arr[0])){
        $t=strtoupper($arr[0]);
    }else{
        $t=strtoupper($mytype);
    }
    if(in_array($t,$GLOBALS['numericTypesAll'])){
    //if(strtoupper(substr($t,0,3))=='INT' or strtoupper(substr($t,0,7))=='NUMERIC' or strtoupper($t)=='FLOAT'){
        */
    $t=tablefieldtype($mytype);
    if(is_tablefieldnumeric($mytype)){
        return "number";
    }elseif($t=='DATE' or $t=='DATETIME' or $t=='TIME'){
        return "date";
    }else{
        return "string";
    }
/*    switch ($t) {
        case 0:
            break;
        case 1:
            echo "i equals 1";
            break;
        case 2:
            echo "i equals 2";
            break;
    }    
*/
}

Function gsclauseand($sql,$clause,$condition=1,$delimiter=' and '){
    if($condition){
        if(strlen($sql)>0 and strlen($clause)>0){
            return $sql.$delimiter.$clause;
        }else{
            if(strlen($sql)>0){
                return $sql;
            }else{
                return $clause;
            }
        }
    }else{
        return $sql;
    }
}

Function iif($if,$t1,$t2=''){
if($if){
    $result= $t1;
}else{
    $result= $t2;
} 
return $result;
}

function gsstr2sql($v){
    return "'". str_replace("'"," ",$v)."'";
}

function gbnull($v){
    if(is_numeric($v)){
        return ($v==0);
    }elseif(is_array($v)){
        return false;
    }else{
        return (strlen(trim($v))==0);
    }
}
function glclng($v){
    if(is_numeric($v)){
        return (intval($v));
    }else{
        return (0);
    }
}

function getFromArray($arr,$term,$default='',$bn=0){
    //falls Array-Term gesetzt, Rückgabe des Wertes, sonst Default
    if (isset($arr[$term])) {
        if($arr[$term]==='' || ($bn and ($arr[$term]=='0' or $arr[$term]==0))){   // or $arr[$term]=='0' or $arr[$term]==0){  problems when you try to set 0
            return $default;
        }else{
            //echo $arr[$term].'<br>';
            return $arr[$term];
        }
    }else{
        return $default;
    }    
}
function InStr($haystack,$needle,$offset=0){
    if(empty($needle) or empty($haystack)){
        return -1;
    }
    $pos=strpos($haystack,$needle,$offset);
    if ($pos !== false){
        return $pos;
    }else{
        return -1;
    }
} 

function isDate($value){
    if(!$value) {
        return false;
    }
    try{
        new \DateTime($value);
        return true;
    } catch (\Exception $e) {
        return false;
    }
}

function mylog($message,$mode=0){
    if(is_array($message)){
        if($mode===1){
            echo '<pre>';
            print_r($message);
            echo '</pre>';
        }elseif($mode===2){
            WriteLog(json_encode($message));
        }
    }else{
        if($mode===1) echo $message.'<br>';
        if($mode===2) WriteLog($message);
    }
}

function WriteLog($txt,$filename='Log.txt',$mode='a'){
    $myfile = fopen($filename, $mode) or die("Unable to open file!");
    //fwrite($myfile, $txt.'\r\n');
    fwrite($myfile, date('d.m.Y h:i:s').' '.$txt.PHP_EOL);
    fclose($myfile);
}

function gsread_file($file){
    $handle=fopen($file,"r");
    $temp=fread($handle,filesize($file));
    fclose($handle);
    return $temp;
}

function gbEmptyStructure($structure){
    if(is_array($structure)){
        foreach($structure as $k => $v){
            if(is_array($v)){
                if(!gbEmptyStructure($v)){
                    return false;
                }
            }elseif(!gbnull($v)){
                //echo $k."=".$v.'<br>';
                return false;
            }
        }
    }
    return true;
}


// ----------------- login / logout ---------------------
function logout(){
    if(isset($_SESSION['userID']))unset($_SESSION['userID']);
    if(isset($_SESSION['username']))unset($_SESSION['username']);
    if(isset($_SESSION['roleID']))unset($_SESSION['roleID']);
    if(isset($_SESSION['roles']))unset($_SESSION['roles']);
    setcookie("login",0,1); //Chrome
    if(isset($_COOKIE['login'])){
        if(setcookie("login",$_COOKIE['login'],1)){ //firefox
            //echo 'cookie gelöscht<br>';
        }else{
            //echo 'cookie nicht gelöscht<br>';
        }
    }
    //exit;
}

function login($name,$pwd,&$error="",$rememberme=0){
    Global $langclass;
    Global $langmodule;
    Global $settings;
    $result=0;
    $_SESSION['userID']=0;
    $_SESSION['roles']=[];
    //$_SESSION["superuser"]=0;
    //$_SESSION["userdispname"]="";
    $_SESSION["username"]="";
    //$_SESSION["password"]="";
    //$_SESSION["user_onlyname"]="";
    //$_SESSION["user_email"]="";
    //$_SESSION["user_array"]=array();
 
    //active:
    //0 not active
    //1 active
    //2 blocked
    //3 deleted
    
    //echo "login :".$name.', $rememberme='.$rememberme."<br>";
    $bwithout_activ=1;
    
    $dat=array();
    $dbclass=new dbclass();
    
    //$data=$getEntries("username='$name'");
    $sql="SELECT * FROM k8login WHERE §clientID and username='$name'";
    $data=$dbclass->getEntries($sql);

    if(!is_array($data)){
        $data=$dbclass->getEntries($sql,0);
    }
    //echo 'Error:'.$getError();
    //echo '<pre>';
    //print_r($data);
    //echo '</pre>';
    
    if($data){
        list($dat)=$data;
        //echo '<pre>';
        //print_r($dat);
        //echo '</pre>';
        if($dat['active']==0){
            //echo 'active==0'.'<br>';
            if($bwithout_activ){
                $result=($dat["password"]==$pwd);
            }else{
                $error=$langclass->getlangValue($langmodule,"account inactive");
            }            
        }elseif($dat['active']==1){
            $result=($dat["password"]==$pwd);
            if(!$result){
              $error=$langclass->getlangValue($langmodule,"password not valid");
            }
        }elseif($dat['active']==2){
            $error=$langclass->getlangValue($langmodule,"account blocked");
        }elseif($dat['active']==3){
            $error=$langclass->getlangValue($langmodule,"account deleted");
        }else{
            $error=$langclass->getlangValue($langmodule,"account inactive");
        }
        //echo '$error='.$error.'<br>';
        //echo '$result='.$result.'<br>';
        //exit;
        if($result){
                $result=$dat["userID"];    
                $_SESSION['userID']=$dat["userID"];
                $_SESSION["username"]=$name;
                $_SESSION["password"]=$pwd;
                //$_SESSION["roleID"]=$dat["roleID"];
                if(!gbnull($dat["roles"]))$_SESSION["roles"]=explode(',',$dat["roles"]);
                //$_SESSION["superuser"]=$dat["superuser"];
                //$_SESSION["userdispname"]=getfromarray($dat,"disptitle",''). " " . $dat["lastname"];
                //setcookie('login',$_SESSION['clientID'].'|'.$_SESSION['username'].'|'.$_SESSION['password'],(time()+60*60*24*3000));
                if($rememberme)$_SESSION['bnewlogin']=1;
        }
    }else{
      $error="user or password not valid!";
    }
    //echo "result:".$result."<br>";
    //echo "Error:".$error."<br>";
    return $result;
}

function gbactivate($addressID,$code){
    $result=0;

    $dat=array();
    $dbclass = new dbclass();
    //$data=$getEntries("addressID=$addressID");
    $sql="SELECT * FROM k8login WHERE §clientID and addressID=$addressID and active=0";
    $data=$dbclass->getEntries($sql);

    if(is_array($data)){
        //echo "adresse gefunden<br>";
        list($dat)=$data;
        if (gdecrypt($code)==$addressID){
            $sql="UPDATE k8login SET active=1 WHERE addressID=".$dat["addressID"];
            $result=$dbclass->db->query($sql);
            return (boolean) $result;
        }
    }
    return false;
}
function gbSendPwd($postfields,&$error,&$message,&$formmode){
    // postfields: username, email
    Global $langclass;
    Global $langmodule;
    Global $domain_name;
    
    $username=getfromarray($postfields,'username','');
    $to=getfromarray($postfields,'email','');
    $dbclass=new dbclass();
    //echo('username:'.$username.'<br>');
    if(gbnull($username) and gbnull($to)){
        $error=$langclass->getlangValue($langmodule,"username").' '.$langclass->getlangValue('system',"invalid").'<br>'.
            $langclass->getlangValue($langmodule,"email").' '.$langclass->getlangValue('system',"invalid").'<br>';
    }elseif(!gbnull($username) and !gbnull($to)){
        $error=$langclass->getlangValue($langmodule,"username").' '
            .$langclass->getlangValue('system',"or")
            .$langclass->getlangValue($langmodule,"email").'<br>';
    }else{
        //echo 'test';
        $sql="SELECT * FROM k8login WHERE ";
        if(gbnull($username)){
            $sql.="§clientID and email=".gsstr2sql($dbclass->db->real_escape_string($to));
            $data=$dbclass->getentries($sql);
        }else{
            $sql.="§clientID and username=".gsstr2sql($dbclass->db->real_escape_string($username));
            $data=$dbclass->getentries($sql);
        }
        if(0){echo '<pre>';
        print_r($data);
        echo '</pre>';}
        if($data){
            list($dat)=$data;
            $to=$dat['email'];
            if(gbnull($to)){
                $error="no email!";
            }else{
                //create new pasword and save
                $dat["password"]=substr(md5(trim(microtime())),0,8);
                $pwd=$dat["password"];
                $sql="UPDATE k8login set password='$pwd' WHERE userID=".$dat['userID'];
                if(!$dbclass->db->query($sql)){
                    $error=$dbclass->error;
                }else{
                    //neues Kennwort senden
                    //$message='mail deactivated';
                    //return 1;
                    $o_mail=new eMailbyServer($to);
                    $o_mail->subject="new password";
                    $o_mail->message="your new password: ".$pwd.'<br>'.'Greetings<br>'.$domain_name;
                    if($o_mail->bsend()){
                        $message="new password sent to your email";
                        return 1;
                    }else{
                        $error=$o_mail->getError();
                        return 0;
                    }
                }
            }
        }else{
            $error=$langclass->getlangValue($langmodule,"username").' '.$langclass->getlangValue('system',"invalid");
            //echo '$dbclass->error='.$dbclass->error;
        }
    }
    return 0;
}

function gbSendContact($postfields,&$error,&$message){
    // postfields: username, email
    Global $langclass;
    Global $langmodule;
    Global $domain_name;
    Global $domain_email;
    
    if(0){echo "<pre>";
    print_r($postfields);
    echo "</pre>";}
    $to=$domain_email;
    $cc=getfromarray($postfields,'email');
    $subject=getfromarray($postfields,'subject');
    $content=getfromarray($postfields,'message');
    
    $sender=getfromarray($postfields,'gender').' '.getfromarray($postfields,'firstname').' '.getfromarray($postfields,'lastname').', Email: '.getfromarray($postfields,'email');
    if(gbnull($subject) or gbnull($to) or gbnull($content)){
        $error=$langclass->getlangValue($langmodule,"please fill out the complete form").'<br>';
        return 0;
    }else{
        $o_mail=new eMailbyServer($to);
        $o_mail->subject=$subject;
        $o_mail->message=$content.'<br><br>'.$sender;
        if($o_mail->bsend()){
            $message="thank you for your message";
            return 1;
        }else{
            $error=$o_mail->getError();
            return 0;
        }
    }
    return 0;
}

function gbcheckDateTime($ts,$datetimestr,$bcheckdate = 1,$bchecktime=1){

    //echo $datetimestr.iif($bcheckdate,"checkdate","")." ".iif($bchecktime,"checktime",""). "<br>";

    $month=0;$day=0;$year=0;$hour=0;$minute=0;$second=0;
    if(gbnull($ts)){
        if(gbnull($datetimestr)){
            return false;
        }else{
            if(instr($datetimestr,":")>=0){
                if(instr($datetimestr," ")>=0){
                    list($datestr,$timestr)=explode(" ",$datetimestr);
                }else{
                    $datestr="";
                    $timestr=$datetimestr;
                }
            }else{
                $datestr=$datetimestr;
                $timestr="";
            }
            //echo '$datetimestr='.$datetimestr."<br>";
            //echo 'instr='.instr($datetimestr," ")."<br>";
            //echo '$datestr='.$datestr."<br>";
            //echo '$timestr='.$timestr."<br>";
            
            if(!gbnull($datestr)){
                if(substr_count($datestr,".")>=2){
                    list($day,$month,$year)=explode(".",$datestr );
                }elseif(substr_count($datestr,"/")>=2){
                    list($month,$day,$year)=explode("/",$datestr );
                }elseif(substr_count($datestr,"-")>=2){
                    list($year,$month,$day)=explode("-",$datestr );
                }else{
                    return false;
                }
            }
            if(!gbnull($timestr)){
                if (substr_count($timestr,":")==1){
                    list($hour,$minute)=explode(":",$timestr);
                }elseif (substr_count($timestr,":")==2){
                    list($hour,$minute,$second)=explode(":",$timestr);
                }else{
                    //echo " return timestr".$datetimestr."<br>";
                    return false;
                }
            }

        }
    }else {
        list($second,$minute,$hour,$day,$month,$year)=explode(".",date("s.i.H.d.m.Y",$ts));
    }
    //echo "Zeit:$second,$minute,$hour<br>";
    if (is_numeric($second) and is_numeric($minute) and is_numeric($hour) and is_numeric($day) and is_numeric($month) and is_numeric($year)){
            //ok
    }else{
        return false;
    }
    $btime=(intval($hour)<=23) and (intval($minute)<=60) and (intval($second)<=60);
    //echo "btime:" .iif($btime,"true","false")."<br>";
    if($bchecktime and $bcheckdate){
        //echo $datetimestr." check date + time <br>";
        //echo iif(checkdate($month,$day,$year),"Datum ok<br>","$month,$day,$year");
        //echo iif($btime,"time ok<br>","");
        return ($btime and checkdate($month,$day,$year));
    }elseif($bchecktime){
        //echo $datetimestr." check  time"."<br>";
        return ($btime);
    }elseif($bcheckdate){
        //echo $datetimestr." check date "."<br>";
        return checkdate($month,$day,$year);
    }else{
        return true;
    }
}

function gsGetValue($s,$del1, $del2=")"){
    $temp="";
    $pos1=strpos($s,$del1);
    if ($pos1 !==false){
        $pos2=strpos($s,$del2,$pos1+strlen($del1));
        if ($pos2 !==false){
            $temp=substr($s,$pos1+strLen($del1 ),$pos2-strlen($del1)-$pos1 );
        }
    }
    return $temp;
}

function data_sel_extendstructure($arr=array()){
    //$arr=array_merge($this->init($arr),$arr);
    if(0){
        echo '<pre>';
        print_r($arr);
        echo '</pre>';
        //exit;
    }
    if(is_array($arr)){
        foreach($arr as $a => $b){
            //echo 'element:'.$a.'<br>';
            if(is_array($arr[$a])){
                $arr[$a]=data_sel_init($arr[$a]);
                if(isset($arr[$a]['subs'])){
                    $arr[$a]['subs']=data_sel_extendstructure($arr[$a]['subs']);
                }
            }
            if(0){
                echo '<pre>';
                print_r($arr[$a]);
                echo '</pre>';
                exit;
            }
        }
    }
    if(0){
        echo 'Result<br>';
        echo '<pre>';
        print_r($arr);
        echo '</pre>';
        //exit;
    }
    return $arr;
}

function data_sel_init($arr=array()){
    $bauto=1;
    if(isset($arr['bauto']))$bauto=$arr['bauto'];
    $dat["ID"]=getfromarray($arr,'ID');
    $dat["object"]=getfromarray($arr,'object');
    $dat["parentID"]=getfromarray($arr,'parentID',0);
    $dat["figure"]=getfromarray($arr,'figure',1);

    $dat["fieldname"]=getfromarray($arr,'fieldname',iif($bauto,getfromarray($arr,'mycolumn')));
    //$dat["label"]=getfromarray($arr,'label',iif($bauto,getfromarray($arr,'mycolumn')));
    $dat["label"]=getfromarray($arr,'label');
    $dat["labelhtml"]=getfromarray($arr,'labelhtml');
    $dat["mytable"]=getfromarray($arr,'mytable');
    $dat["mycolumn"]=getfromarray($arr,'mycolumn');
    $dat["inwhere"]=getfromarray($arr,'inwhere');
    $dat["datatype"]=getfromarray($arr,'datatype',0);
    $dat["fieldtype"]=getfromarray($arr,'fieldtype',0);
    $dat["specification"]=getfromarray($arr,'specification');
    $dat["asclause"]=getfromarray($arr,'asclause');
    $dat["obligatory"]=getfromarray($arr,'obligatory',0);
    $dat["width"]=getfromarray($arr,'width',0);
    $dat["mydefault"]=getfromarray($arr,'mydefault');
    $dat["mytype"]=getfromarray($arr,'mytype');
    $dat["myextra"]=getfromarray($arr,'myextra');
    $dat["decimals"]=getfromarray($arr,'decimals',0);
    $dat["sameline"]=getfromarray($arr,'sameline',0);
    $dat["height"]=getfromarray($arr,'height',0);
    $dat["alignement"]=getfromarray($arr,'alignement',0);
    $dat["top"]=getfromarray($arr,'top',0);
    $dat["leftpos"]=getfromarray($arr,'leftpos',0);
    $dat["htmltag"]=getfromarray($arr,'htmltag');
    $dat["format"]=getfromarray($arr,'format');
    $dat["class"]=getfromarray($arr,'class');
    $dat["style"]=getfromarray($arr,'style');
    $dat["checktype"]=getfromarray($arr,'checktype');
    $dat["checkdetails"]=getfromarray($arr,'checkdetails');
    $dat["aggregation"]=getfromarray($arr,'aggregation',0);
    $dat['shrinkable']=getfromarray($arr,'shrinkable',0);
    $dat['enlargeable']=getfromarray($arr,'enlargeable',0);
    $dat['parentlinkfields']=getfromarray($arr,'parentlinkfields');
    $dat['childlinkfields']=getfromarray($arr,'childlinkfields');
    $dat['newpage']=getfromarray($arr,'newpage',0);
    $dat['fontcolor']=getfromarray($arr,'fontcolor');
    $dat['backgroundcolor']=getfromarray($arr,'backgroundcolor');
    $dat['border']=getfromarray($arr,'border');
    $dat['bordercolor']=getfromarray($arr,'bordercolor');
    $dat['fontname']=getfromarray($arr,'fontname');
    $dat['fontsize']=getfromarray($arr,'fontsize',0);
    $dat['fontstyle']=getfromarray($arr,'fontstyle');        
    $dat['visible']=getfromarray($arr,'visible',1); 
    $dat['visibleeval']=getfromarray($arr,'visibleeval'); 
    $dat['enabled']=getfromarray($arr,'enabled',1);  
    $dat['javascript']=getfromarray($arr,'javascript');  
    if(isset($arr['subs']))$dat['subs']=$arr['subs'];
    return $dat;
}

// --------------------  Formatierung von Nummern (tcpdf)
function number_formatx($number,$dp=-1,$from=-1){
    //return number in generalformat
    //
    //$from -1: generalformat
    //       0: american
    //       1: european
    if($from==-1){
        $from=getfromarray($_SESSION,'generalformat',0);
    }
    if($from==1){
        // first 2 english
        //$temp=str_replace(".","D",$number);
        //$temp=str_replace(",","T",$temp);
        //$temp=str_replace("D",",",$temp);
        //$number=str_replace("T","",$temp);
        $temp=str_replace(",","D",$number);
        $temp=str_replace(".","T",$temp);
        $temp=str_replace("D",".",$temp);
        $number=str_replace("T","",$temp);
        //echo "Number:".$number.'<br>';
    }
    if(getfromarray($_SESSION,'generalformat',0)){
        $thousand='.';
        $decimal=',';
    }else{
        $thousand=',';
        $decimal='.';
    }
    if(!is_numeric($number)){
        //echo "Number:".$number.'<br>';
        $number=0;
    }
    if($dp==-1){
        return gnumber_convert($number,$from,getfromarray($_SESSION,'generalformat',0));
    }else{
        return number_format($number,$dp,$decimal,$thousand);
    }
}

function gnumber($number,$bgeneralformat=1){
    return number($number,$bgeneralformat);
}
function number($number,$bgeneralformat=1){
    // convert to the internalformat
    // ',' -> '.'
    if($bgeneralformat){
        $generalformat=getfromarray($_SESSION,'generalformat',0);
    }else{
        $generalformat=0;
    }
    if($generalformat==1){
        $temp=str_replace(",","D",$number);
        $temp=str_replace(".","T",$temp);
        $temp=str_replace("D",".",$temp);
        $temp=str_replace("T","",$temp);
        //echo "T".str_replace("T",",",$temp).'<br>';
        $temp=floatval($temp);
        //echo "float".str_replace("T",",",$temp).'<br>';
        return $temp;
    }else{
        return floatval(str_replace(",","",$number));
    }
}

function gnumber_convert($temp,$from,$to){
    //echo 'temp: '.$temp.' from: '.$from.' to: '.$to.'<br>';
    if($from==$to){
        return $temp;
    }else{
        if($from==1){
            $dec_source=',';
            $tho_source='.';
            $dec_target='.';
            $tho_target=',';
        }else{
            $dec_source='.';
            $tho_source=',';
            $dec_target=',';
            $tho_target='.';
        }
        $temp=str_replace($dec_source,"D",$temp);
        $temp=str_replace($tho_source,"T",$temp);
        $temp=str_replace("D",$dec_target,$temp);
        $temp=str_replace("T",$tho_target,$temp);
        //echo 'temp: '.$temp.'<br>';
        return $temp;
    }
}

function gformat_number($temp,$to,$from=-1){
    // to=1 nach data_enter, =0 nach data save
    if($_SESSION["generalformat"]==1){
        if($to){
            $temp=str_replace(",","D",$temp);
            $temp=str_replace(".","T",$temp);
            $temp=str_replace("D",".",$temp);
            $temp=str_replace("T",",",$temp);
            return $temp;
        }else{
            $temp=str_replace(".","T",$temp);
            $temp=str_replace(",","D",$temp);
            $temp=str_replace("D",".",$temp);
            $temp=str_replace("T",",",$temp);
            return $temp;
        }
    }else{
        return $temp;
    }
}

class eMailbyServer{
    
    private $to;
    public $subject;    
    public $message;
    public $from;
    public $attachements;
    //private $content;
    //private $header;
    private $error;
    
    public function __construct($to,$dat=array(),$typ=0){
        //Global $settings;
        Global $domain_name;
        Global $domain_email;
        $domain_name='Example Website';
        // BasicFunctions: $domain_language='en';
        $domain_email='mail@example.com';
      
        $this->to=$to;
        // $typ laden
        // $dat
        $this->subject='';
        $this->message='';
        $this->from="$domain_name<$domain_email>";
    }
    
    public function bprepareAttachment($filename,$temporary=0){
        if(file_exists($filename)){
            $anhang = array();
            $anhang["filename"] = $filename;
            $anhang["name"] = basename($filename);
            $anhang["size"] = filesize($filename);
            $handle=fopen($filename,"r");
            $temp=fread($handle,filesize($filename));
            /*$bom = pack("CCC", 0xef, 0xbb, 0xbf);   // BOM entfernen
            if (0 == strncmp($temp, $bom, 3)) {
                $temp = substr($str, 3);
            } */               
            fclose($handle);
            $anhang["data"] = chunk_split(base64_encode($temp))."\r\n";
            if(function_exists("mime_content_type")){
                $anhang["type"] = mime_content_type($filename);
            }else{
                $anhang["type"] = "application/octet-stream";
            }
            $anhang["temporary"]=$temporary;
            $this->attachements[]=$anhang;
            return 1;
        }else{
            $this->error="file doesn't exist";
            return 0;
        }
    }
    
    public function getError(){
        return $this->error;
    }
    public function bSend(){
        Global $settings;
        // check properties
        if(gbnull($this->to)){
            $this->error="to missing";
            return 0;
        }
        if(gbnull($this->subject)){
            $this->error="subject missing";
            return 0;
        }
        
        // send
        if(count($this->attachements)>0){
            $mime_boundary = md5(uniqid(mt_rand(), 1));
            //$header  ="From:".getfromarray($settings,'3201','')."<".$this->from.">\n";
            $header  ="From:".$this->from."\n";
            $header.= "MIME-Version: 1.0\r\n";
            $header.= "Content-Type: multipart/mixed; boundary=".$mime_boundary."\r\n\r\n";

            //Mailbody
            $content='';
            $content.= "--".$mime_boundary."\r\n";
            $content.= "Content-Type: text/html; charset=utf-8\r\n";
            $content.= "Content-Transfer-Encoding: 8bit\r\n\r\n";
            $content.= $this->message."\r\n";
            

            // add attachment
            foreach($this->attachements as $anhang){
                $content.= "--".$mime_boundary."\r\n";
                $content.= "Content-Type: ".$anhang['type']."; name=".$anhang['name']."\r\n";
                $content.= "Content-Disposition: attachment; filename=".$anhang['name']."\r\n";
                $content.= "Content-Transfer-Encoding: base64\r\n";
                $content.= "\r\n";
                $content.= $anhang['data']; //."\r\n";
            }

            ini_set('sendmail_from', $this->from);
            $b=mail($this->to,'=?UTF-8?B?'.base64_encode($this->subject).'?=',$content,$header);
            
            // Delete temporary files?
            foreach($this->attachements as $anhang){
                if(getfromarray($anhang,'temporary',0)){
                    unlink($anhang['filename']); // Datei löschen
                }
            }
        }else{
            $header  = "MIME-Version: 1.0\r\n";
            $header .= "Content-type: text/html; charset=UTF-8\r\n";
            ini_set('sendmail_from', $this->from);
            $b=mail($this->to,$this->subject,$this->message,$header);
        }
        return $b;
    }
    
}
/*
function getDatadefinition($datadefID,$masterkeyvalue="",$rightuser_create_master=0){
  // check rightuser_create
  //echo 'getDatadefinition'.'br';
  global $datadefinitions;
  if(isset($datadefinitions[$datadefID])){
    if(getfromArray($datadefinitions[$datadefID],'rightcheck',0)<>0){
      $o=new $datadefinitions[$datadefID]['objectclass']($datadefinitions[$datadefID]);
      //echo '$o->error='.$o->error.'<br>';
      if(gbnull($o->error)){
        if($o->rightcheck<>0){
          if(!isset($o->permit['create'])){
            // nothing allowed
          }elseif(count($o->roles)>0){
            foreach($o->roles as $roleID){
              $method=getFromArray($o->permit['create'],$roleID,0);
              //echo 'roles[] $method='.$method.'br';
              if($method==1000){
                $datadefinitions[$datadefID]['masterdata']['rightuser_create']=$o->bcheckMaster($masterkeyvalue,'update',$roleID);
              }else{
                $arr=array("method"=>$method);
                if($o->dbclass->bRecordAccess($arr)){
                  $datadefinitions[$datadefID]['masterdata']['rightuser_create']=true;
                  break;
                }
              }
            }
          }else{
              //echo 'roleID $method='.$method.'br';
              $method=getFromArray($o->permit['create'],$o->roleID,0);
              if($method==1000){
                $datadefinitions[$datadefID]['masterdata']['rightuser_create']=$o->bcheckMaster($masterkeyvalue,'update',$o->roleID);
              }else{
                $arr=array("method"=>$method);
                $datadefinitions[$datadefID]['masterdata']['rightuser_create']=$o->dbclass->bRecordAccess($arr);
              }
          }
        }
      }
    }else{
       $datadefinitions[$datadefID]['masterdata']['rightuser_create']=1;
    }
  }else{
    // not defined
  }
  return $datadefinitions[$datadefID];
}
*/

function gbnofields_missing($postfields,&$error,$fieldsbool,$fieldsrequired,&$prep_output,$formname){        // Required fields
    Global $langclass;
    Global $langmodule;
    $jslist='';    
    $fieldsmissinglist='';
    //echo '$fieldsrequired:'.$fieldsrequired."<br>";
    if(!gbnull(trim($fieldsrequired))){
        $temp=  str_replace("[", "", trim($fieldsrequired));
        $temp=  str_replace("]", "", $temp);
        //echo "T:".$temp."<br>";
        $arr=explode(",",$temp);
        $fieldsmissing=" ";
        foreach($arr as $k){
            if(!gbnull($k)){
                $bmissing=0;
                if(isset($postfields[$k])){
                    if (strpos($fieldsbool,"[".$k."]")!==false) {
                        $bmissing=!($postfields[$k]==0 or $postfields[$k]==1);
                    }else{
                        $bmissing=gbnull(getfromarray($postfields,$k,''));
                    }
                }else{
                    // error
                    $bmissing=1;
                }
                if($bmissing){
                    //$jslist.="window.document.abook.$k.style.border=\"thin solid #FF6347\";";
                    $jslist.="window.document.$formname.$k.style.backgroundColor=\"#f4e2df\";\n";
                    $fieldsmissing.="[".$k."],";
                    //echo $langmodule.', '.$k.'<br>';
                    $fieldsmissinglist.=$langclass->getlangValue($langmodule,$k).", ";
                }
            }
        }
        if(!gbnull(trim($fieldsmissing))){
            // ." " . $this->fieldsmissing
            $prep_output.="<script type=\"text/javascript\"> \nfunction colorfields(){";
            $prep_output.= $jslist;
            $prep_output.="}\n</script>";
            $error.=$langclass->getlangValue("system","data_fields_required_missing")  ."<br>".substr($fieldsmissinglist,0,strlen($fieldsmissinglist)-2)."<br>";
        }
    }  
    return (gbnull($error));
}
