<?php
// Last updated 09.04.2020 09:00, copyright Klaus Eisert
// Last updated 03.04.2020 09:00, copyright Klaus Eisert
require_once "class_check.php";

class data_accessclass{  /*datadefID*/
    public $datadefinition;
    public $class_version;
    public $db;
    public $dbclass;
    public $error;
    public $table;
    private $clientID;
    private $creatorID;
    public $creatormode;
    public $colobject;
    
    public $fieldssystem;
    public $fieldlist;
    public $fieldsnum;
    public $fieldscur;
    public $fieldsdate;
    public $fieldsbool;
    public $key;
    public $keyvalue;
    
    public $sql;
    public $sql_base;    
    public $orderby;
    public $sql_statement;
    
    public $fieldsdisplay;
    public $fieldsrequired;
    public $fieldsmissing;
    public $fieldlistlist;
    public $check;
    
    public $postfields;
    public $data;
    public $dat;
    public $output;
    public $bdatfrompost;
    
    public $roleID;
    public $roles;
    public $permit;
    public $rightcheck; // default=1
    
    public $bobjectread;
    private $type;   // festgelegte Eigenschaft für datadefinitions->bshowlist, muß vor getentries gefüllt sein
    public $header;

    public $rightmode;  // depricated
    public $omaster;
    public $masterkey;  
    public $masterdatadefID;
    public $childs;
    public $baddimage;

    public $include;
    
    public function __construct($datadefinition) {
        //echo '<pre>';
        //print_r($datadefinition);
        //echo '</pre>';
        $this->datadefinition=$datadefinition;
        $this->table=$datadefinition['table'];
        $this->key=$datadefinition['key'];
        $this->colobject=table2colobject($datadefinition['columns']);
        $this->clientID=getFromArray($_SESSION,"clientID",0);
        $this->creatorID=getfromarray($_SESSION,"userID",0);  //,getfromarray($_COOKIE,"userID",0));

        $this->keyvalue=0;
        $this->include=array();

        $this->creatormode=1;   // 0=no creator, 1=creatorID, 2=creator.creatorID, 3=companyID
        $this->sql_base='';
        $this->sql='';

        $this->dbclass = new dbclass();
        if(!gbnull($this->dbclass->error)){
            $this->error=$this->dbclass->error;
            return false;
        }
        $this->db = $this->dbclass->db;        

        $this->check= new check();
        $this->data=array();
        $this->dat=array();
        $this->output='';
        $this->bdatfrompost=0;
        $this->postfields='';

        //echo 'data_accesss='.'<br>';
        //rights=20:    //creatorID=Session[userID]
        //rights=30:    //creatorID in addresses  
        //rights=40:    //companyID
        
        //deprecated:
        $this->rightmode=getfromarray($datadefinition,'rightmode'); //0=Standard new, 1=parent, 2=old


        // --------------------- master
        $this->omaster=0;
        $this->masterkey=getfromarray($datadefinition,'masterkey');
        $this->masterdatadefID=getfromarray($datadefinition,'masterdatadefID');
        if(!gbnull($this->masterdatadefID)){
          //echo '$this->masterdatadefID='.$this->masterdatadefID.'<br>';
          getDatadefinition($this->masterdatadefID);
        }
        
        // 0=public, 1=admin client, 2=superuser, 3=member, 4=company, 5=friend
        if(isset($_SESSION['roles'])){
          $this->roles=$_SESSION['roles'];
        }else{
          $this->roles[]=0;
        }
        //$this->roleID=getFromArray($_SESSION,'roleID',0);
        //$this->roles[]=$this->roleID;
        //$this->roles[]=5;
        
        //echo '<pre>';
        //print_r($datadefinition);
        //echo '</pre>';
        
        if(isset($datadefinition['masterdata'])){
          $this->sql_statement=getfromarray($datadefinition['masterdata'],'sql_statement');
        }else{
          $datadefinition['masterdata']=array();
        }
        
        if(getfromarray($datadefinition['masterdata'],'defaultrights',1)){
          if(gbnull($this->masterdatadefID)){
            //$this->permit=array("create"=>array(0=>0,1=>2,2=>2,3=>2),"read"=>array(0=>2,1=>2,2=>2,3=>2),"update"=>array(0=>0,1=>2,2=>2,3=>10),"delete"=>array(0=>0,1=>2,2=>2,3=>10));
            $this->permit=array("create"=>array(0=>0,1=>2,2=>2,3=>2),"read"=>array(0=>0,1=>2,2=>2,3=>10),"update"=>array(0=>0,1=>2,2=>2,3=>10),"delete"=>array(0=>0,1=>2,2=>2,3=>10));
          }else{
            //$this->permit=array("create"=>array(0=>0,1=>2,2=>2,3=>1000),"read"=>array(0=>2,1=>2,2=>2,3=>1000),"update"=>array(0=>0,1=>2,2=>2,3=>1000),"delete"=>array(0=>0,1=>2,2=>2,3=>1000));
            $this->permit=array("create"=>array(0=>0,1=>2,2=>2,3=>1000),"read"=>array(0=>0,1=>2,2=>2,3=>1000),"update"=>array(0=>0,1=>2,2=>2,3=>1000),"delete"=>array(0=>0,1=>2,2=>2,3=>1000));
          }
        }
        $this->rightcheck=getfromarray($datadefinition,'rightcheck',1); //0=no check, 1=matrix


        //loop datadefinition rights
        if(isset($datadefinition['masterdata']['rights'])){
          foreach($datadefinition['masterdata']['rights'] as $access=>$i){
              foreach($i as $group => $v){
                //echo '$access='.$access.' $group='.$group.'<br>';
                $this->permit[$access][$group]=$v;
              }
          }
        }
        
        if(!isset($datadefinition['masterdata']['upload'])){
          $datadefinition['masterdata']['upload']=array();
        }
        $this->baddimage=getfromarray($datadefinition['masterdata']['upload'],'enabled',0);
        if($this->baddimage){
            $datadefimageID=8;
            if(!isset($datadefinitions[$datadefimageID]))getDatadefinition($datadefimageID);
        }

        // ---------------------------- childs
        $this->childs=array();
        if(isset($datadefinition['childs'])){
            $this->childs=$datadefinition['childs'];
            foreach($datadefinition['childs'] as $index => $child){
                $this->childs[$index]['objectclass']=$child['objectclass'];
                if(isset($child['requiredfile']))$this->childs[$index]['requiredfile']=$child['requiredfile'];
                //echo '$requiredfile='.$requiredfile.'<br>';
                $requiredfile=getfromArray($this->childs[$index],'requiredfile');
                if(!gbnull($requiredfile))require_once $requiredfile;
                
                $this->childs[$index]['fieldname']=$child['fieldname'];
                
                $child['columns']=$this->dbclass->ShowTable($child['table'],$child['key']);
                if(!gbnull($this->dbclass->error)){
                    $this->error=$this->dbclass->error;
                    //goto end;
                }
                //if(isset($child['key'])
                $this->childs[$index]['o_class']=new $child['objectclass']($child);
            }
        }
        
        if(isset($datadefinition['masterdata']['include'])){
          foreach($datadefinition['masterdata']['include'] as $k=>$v){
            $this->include[$k]=$v;
          }
        }

    }
    
    public function Gettable(){
      return $this->table;
    }

    /*
    public function bsettable($datadefinition){
        $this->table=$datadefinition['table'];
        $this->key=$datadefinition['key'];
        $this->colobject=table2colobject($datadefinition['columns']);
    }
    */
    
    public function initType($typeID=0,$bnew=0) {
        Global $settings;
        Global $prep_output;
        if(1){  //$typeID
            //$this->fieldsdisplay.='';
            //$this->fieldsrequired.='';
        }
        //echo 'fieldsdisplay:'.$this->fieldsdisplay.'<br>';
    }

    public function init($arr=[]){
        Global $settings;
        Global $generaldateformat;

        /*&&class__init&&*/
        /*&&class_init&&*/

        $dat=array();

        foreach($this->colobject as $k=>$col){
            if(isset($this->colobject[$k]['mydefault'])){
                $dat[$k]=$this->colobject[$k]['mydefault'];
            }
        }

        foreach($_GET as $k=>$v){
            if(isset($this->colobject[$k]) and $k<>$this->key){
                $dat[$k]=$v;
            }
        }
        $this->dat=$dat;
        $this->data=array();
        $this->data[0]=$this->dat;
        return $dat;
    }
    public function getNextSort($clause,$inc=10,$sortcolumn="sort"){
        //"§clientID and basetype='".$basetype."' and baseID=".$baseID
        return $this->dbclass->expression('max('.$sortcolumn.')',$this->table,$clause,0)+$inc;
    }
    public function sort($arr,$prefix="sort_"){
        if(is_array($arr)){
          $index=1;
          $inc=1;
          $ID=0;
          $sortfield=getFromArray($this->datadefinition,'sortcolumn',"sort");
          if(!isset($this->colobject['sort'])){
            $this->error="field sort not set!";
            return false;
          }
          for ($i = 0; $i <count($arr); $i++) {
              $ID=str_replace($prefix,'',$arr[$i]);
              if($ID<>0){
                  $sql = 'UPDATE '.$this->table.' SET '.$sortfield.'='.$index.' WHERE '.$this->key.'=?';
                  $stmt = $this->db->prepare($sql);
                  $stmt->bind_param('i', $ID);
                  $stmt->execute();
                  $result = $stmt->affected_rows;
                  $stmt->close();
                  $index+=$inc;
              }
          }
        }
        return true;
    }
    
    public function getError() {
        return $this->error;
    }

    public function bvalidate($postfields) {
        // Rüpckgabe $error
        Global $langclass;
        Global $langmodule;
        Global $prep_output;
        Global $formname;
        Global $settings;
        Global $generaldateformat;

        //echo "davor ".$this->table."<br>";
        //echo '<pre>';
        //print_r($postfields);
        //echo '</pre>';
        
        $this->postfields=$postfields;
        $this->keyvalue=getFromArray($this->postfields,$this->key);

        $bnew=(gbnull(getfromArray($this->postfields,$this->key)));
        $this->error="";
        
        //Besonderheiten checkbox
        /*if(strpos($this->fieldsdisplay,"[active]")!==false){
            $this->postfields["active"]=getfromarray($this->postfields,"active",1);
        }*/ 


        //WICHTIG !!!
        //$this->postfields=gformatpostfields($this->postfields, $this->fieldsnum.$this->fieldscur,$this->fieldsdate);   //change formatting of numeric and date fields
        //$datatype=gbGetDatatype($this->table);                          
        $this->check->gbcheckinputcol($this->colobject,$this->postfields,$error);
        
        if($this->table=="k8references" and getFromArray($this->postfields,'type')=="image"){
          $ID=getFromArray($this->postfields,'ID',0);
          if(gbnull($ID) and empty($_FILES)){
            $this->error.="no image";
          }
        }
        //gbnofields_missing($this->postfields,$error,$this->fieldsbool,$this->fieldsrequired,$prep_output,$formname); //required fields
        //if(gbnull(getfromarray($this->postfields,'creatorID','')))$this->postfields['creatorID']=getfromarray($_SESSION,'userID',0);
        
        if(isset($this->include['validate'])){
            include str_repeat('../',$GLOBALS['script_depth']).$this->include['validate'];
        }

        if(gbnull($this->error)){
            // --------------- childs --------------------
            foreach($this->childs as $index => $x){
                //echo '$index='.$index.'<br>';
                if(isset($this->postfields[$this->childs[$index]['fieldname']])){
                    foreach($this->postfields[$this->childs[$index]['fieldname']] as $k => $v){
                        //echo '$k='.$k.'<br>';
                        if(gbEmptyStructure($v)){
                            unset($this->postfields[$this->childs[$index]['fieldname']][$k]);
                        }else{                            
                            $this->childs[$index]['o_class']->postfields=$v;

                            if($this->childs[$index]['o_class']->bvalidate($v)){
                                //fehlerhaft  !!!  $this->postfields[$this->childs[$index]['fieldname']]=$this->childs[$index]['o_class']->postfields;
                            }else{
                                $this->error.=$this->childs[$index]['o_class']->getError();
                            }
                        }
                    }
                }
            }
        }
        
        return gbnull($this->error);
    }

    public function save(){
        $echo=0;
        $bnew=0;
        $myres=0;
        if(gbnull($this->keyvalue)){
            if(!gbEmptyStructure($this->postfields)){
                $myres=$this->add();
                $bnew=1;
                if(!gbnull($myres) and $this->table=="k8references" and !empty($_FILES)){
                    $end="";
                    $sql_set="";
                    $text=$_FILES["file"]["name"];
                    $pos=strrpos($text,".");
                    if($pos!==false){
                        $end=substr($text,$pos+1);
                    }
                    $image_info = getimagesize($_FILES["file"]["tmp_name"]);
                    if($image_info !== false){
                        // https://www.geeksforgeeks.org/php-getimagesize-function/
                        $mimetypen = array (
                          "image/jpeg" => "jpg",
                          "image/gif" => "gif",
                          "image/png" => "png"
                        );
                        
                        $sort=$this->getNextSort('clientID='.$this->clientID.' and basetype='.gsstr2sql($this->postfields['basetype']).' and baseID='.$this->postfields['baseID']);
                        $sql_set.="width='".$image_info[0]."',height='".$image_info[1]."',sort='".$sort."',filetype='".$end."',";
                    }
                    $storeFolder = '../uploads'; 
                    $tempFile = $_FILES['file']['tmp_name'];
                    $targetPath = dirname( __FILE__ ).DIRECTORY_SEPARATOR.$storeFolder.DIRECTORY_SEPARATOR; 
                    //$targetFile =  $targetPath. $_FILES['file']['name'];
                    $filename=getFromArray($this->postfields,'basetype').'_'.$myres.'.'.$end;
                    $targetFile =  $targetPath.$filename;
                    move_uploaded_file($tempFile,$targetFile); 
                    //sort, filetype, height, width, aspectratio
                    
                    $sql_set.="path='uploads',filename='".$filename."',";
                    $result=$this->db->query("Update k8references set ".substr($sql_set,0,-1)." WHERE ID=".$myres);      
                    if (!$result){
                      $this->error= "(".$this->db->errno.") " . $this->db->error;
                    }
                }
            }
        }elseif($this->bexist($this->keyvalue,0,1)){
            if($this->update()){
                $myres=$this->keyvalue;
            }
        }else{
            $this->error=$this->keyvalue.' doesn`t exists!<br>';
        }
        
        if($myres){
            $postfields=$this->postfields;
            if(gbnull($this->keyvalue))$postfields[$this->key]=$myres;
            //and isset($o->postfields['deliverydate']
            if($echo)mylog($this->table.' Main successful, '.$this->key.'='.$postfields[$this->key].'<br>',$echo);

            //if($echo){
            if(0){
                echo $this->table.'$postfields'.'<br>';
                echo '<pre>';
                print_r($postfields);
                echo '</pre>';
                exit;
            }
            
            // ============================================================ save childs
            //if($echo)echo $this->table.' count(childs)='.count($this->childs).'<br>';
            foreach($this->childs as $index => $child){
                $item_in='';
                if(isset($postfields[$child['fieldname']])){
                    foreach($postfields[$child['fieldname']] as $k=>$dat){
                        
                        //set parentkey
                        $dat[$this->childs[$index]['o_class']->masterkey]=getfromarray($postfields,$this->key);
                        
                        //echo 'masterkey='.$this->childs[$index]['o_class']->masterkey.'<br>';
                        //if($echo)echo $this->table.' index='.$k.'<br>'; // 'key='.$this->o_main->postfields[$this->o_main->key].'<br>';
                        if($this->childs[$index]['o_class']->bvalidate($dat)){
                            //if($echo){
                            if(0){
                                echo '<pre>';
                                print_r($this->childs[$index]['o_class']->postfields);
                                echo '</pre>';
                            }
                            
                            // values are in $dat=$this->childs[$index]['o_class']->postfields;
                            $ressub=$this->childs[$index]['o_class']->save();
                            if($ressub){
                                $dat[$this->childs[$index]['o_class']->key]=$ressub;
                                $item_in.=$dat[$this->childs[$index]['o_class']->key].',';
                            }else{
                                $this->error.=$this->childs[$index]['o_class']->getError();                            
                            }
                        }else{
                            $this->error.=$this->childs[$index]['o_class']->getError();
                        }
                        //echo '$this->error='.$error.'<br>';
                        //exit;
                    }
                }
                if(!$bnew){
                    // ggf Positionen löschen
                    if(count($this->childs[$index]['o_class']->childs)>0){
                        // rekursive löschen
                        $clause=gsclauseand($this->childs[$index]['o_class']->masterkey.'='.$postfields[$this->key],'not '.$this->childs[$index]['o_class']->key.' in('.substr($item_in,0,strlen($item_in)-1).')',!gbnull($item_in));
                        if($echo)mylog($this->childs[$index]['o_class']->table.' check to delete Pos?.$clause='.$clause,$echo);
                        $data_del=$this->childs[$index]['o_class']->getEntries($clause);
                        if($data_del){
                            foreach($data_del as $dat_del){
                                if($echo)mylog($this->childs[$index]['o_class']->table.' delete Pos='.$this->childs[$index]['o_class']->key.'.'.$dat_del[$this->childs[$index]['o_class']->key],$echo);
                                if($this->childs[$index]['o_class']->delete($dat_del[$this->childs[$index]['o_class']->key])){
                                }else{
                                    $this->error.=$this->childs[$index]['o_class']->geterror();
                                }
                            }
                        }else{
                            if($echo)mylog('no pos to delete<br>',$echo);
                        }
                    }else{
                        // without children SQL-DELETE
                        $clause=gsclauseand($this->childs[$index]['o_class']->masterkey.'='.$postfields[$this->key],'not '.$this->childs[$index]['o_class']->key.' in('.substr($item_in,0,strlen($item_in)-1).')',!gbnull($item_in));
                        $sql='DELETE FROM '.$this->childs[$index]['o_class']->table.' WHERE '.$clause;
                        //if($echo)echo $this->table.','.htmlspecialchars($sql).'<br>';
                        if(!$this->childs[$index]['o_class']->db->query($sql)){
                            $this->error.=$this->childs[$index]['o_class']->geterror();
                        }
                    }
                }
            }
            //if($echo)exit;
        }else{
            //if($echo) echo $this->table.' not successful, '.'<br>';
        }
        
        return $myres;
    }
    
    public function add() {
        $result=0;
        $bok=0;
        
        if(isset($this->colobject['userID'])){
          $this->postfields['userID']=getfromarray($_SESSION,'userID');
        }

        $clause=$this->key.'='.$this->keyvalue;
        if($this->rightcheck==0){
          $bok=1;
        }elseif($this->rightcheck==1){
          if(!isset($this->permit['create'])){
            //nothing allowed
          }elseif(count($this->roles)>0){
            foreach($this->roles as $roleID){
              $method=getFromArray($this->permit['create'],$roleID,0);
              //echo '$roleID='.$this->roleID.'<br>';
              //echo '$method='.$method.'<br>';
              if($method==1000){
                $bok=$this->bcheckMaster($this->postfields[$this->masterkey],'update',$roleID);
              }else{
                $arr=array("method"=>$method,"table"=>$this->table,"clause"=>$clause);
                If($this->dbclass->bRecordAccess($arr)){
                  $bok=1;
                }else{
                  $this->error=$this->dbclass->error;
                  break;
                }
              }
              if($bok)break;
            }
          }else{
            $method=getFromArray($this->permit['create'],$this->roleID,0);
            //echo '$this->roleID='.$this->roleID.'<br>';
            //echo '$method='.$method.'<br>';
            if($method==1000){
              $bok=$this->bcheckMaster($this->postfields[$this->masterkey],'update',$this->roleID);
            }else{
              $arr=array("method"=>$method,"table"=>$this->table,"clause"=>$clause);
              If($this->dbclass->bRecordAccess($arr)){
                $bok=1;
              }else{
                $this->error=$this->dbclass->error;
              }
            }
          }
        }
        
        if($bok){
          $sqlfields='';
          $sqlvalues='';
          /*echo "<pre>";print_r($this->colobject);echo "</pre>";*/
          
          if(isset($this->colobject['clientID'])){
              $sqlfields.='clientID, ';
              $sqlvalues.= "'$this->clientID', ";
          }
          if(isset($this->colobject['creatorID'])){ 
          //if(isset($this->colobject['creatorID']) or isset($this->colobject['userID'])){ // problem with dataAccount.php
              $sqlfields.='creatorID, ';
              $sqlvalues.= "'$this->creatorID', ";
          }
          if(isset($this->colobject['userID'])){
              $sqlfields.='userID, ';
              $sqlvalues.= "'$this->creatorID', ";
          }
          if(isset($this->colobject['datecreated'])){
              $sqlfields.='datecreated, ';
              $sqlvalues.= "Now(), ";
          }
          if(isset($this->colobject['datetimecreated'])){
              $sqlfields.='datetimecreated, ';
              $sqlvalues.= "Now(), ";
          }
          if(isset($this->colobject['companyID'])){
              $sqlfields.='companyID, ';
              $sqlvalues.=gsstr2sql(getformarray($_SESSION,'companyID',0)).', ';
          }
          
          // Default values
          foreach($this->colobject as $column){
            if(getfromarray($column,'noinsert',0) and isset($column['mydefault'])){
              if(instr(',clientID,creatorID,datecreated,datetimecreated,companyID',','.$column['fieldname'].',')===-1 and !gbnull($column['fieldname'])){
                $sqlfields.=$column['fieldname'].', ';
                $sqlvalues.=gsstr2sql($column['mydefault']).', ';
              }
            }
          }
          
          $this->dbclass->buildSqlInsertFromInput($this->colobject,$this->postfields,$sqlfields,$sqlvalues); 
          
          $this->sql = 'INSERT INTO ' . $this->table . '(';
          $this->sql=$this->sql . substr($sqlfields,0,-2) . ') ';
          $this->sql=$this->sql . ' VALUES(' . substr($sqlvalues,0,-2) . ') ';
          //echo htmlspecialchars($this->sql).'<br>';
          //exit;
          
          $result=$this->db->query($this->sql);
          //echo "Result: " . $result;
          if (!$result){
              $this->error= "(".$this->db->errno.") " . $this->db->error;
              //echo $this->error . "<BR>";
          }else{
              $result=$this->db->insert_id;
              if($this->table=='k8login'){
                $this->db->query("Update k8login set creatorID=userID WHERE userID=".$result);      
              }
          }
        }
        return $result;
    }
    
    public function update() {
        //echo 'update '.$this->table.', key='.$this->key.'<br>';
        
        $result=0;
        $bok=0;
        $clause=$this->key.'='.$this->keyvalue;
        if($this->rightcheck==0){
          $bok=1;
        }elseif($this->rightcheck==1){
          if(0){
            echo '<pre>';
            echo '$this->permit[update]:'.'<br>';
            print_r($this->permit['update']);
            echo '</pre>';
            echo 'this->roleID='.$this->roleID.'<br>';
          }
          $permission="update";
          if(!isset($this->permit[$permission])){
            // nothing allowed
          }elseif(count($this->roles)>0){
            foreach($this->roles as $roleID){
              $method=getFromArray($this->permit[$permission],$roleID,0);
              //echo '$this->roleID='.$this->roleID.'<br>';
              //echo '$method='.$method.'<br>';
              if($method==1000){
                $bok=$this->bcheckMaster($this->postfields[$this->masterkey],'update',$roleID);
              }else{
                $arr=array("method"=>$method,"table"=>$this->table,"clause"=>$clause);
                If($this->dbclass->bRecordAccess($arr)){
                  $bok=1;
                }else{
                  $this->error=$this->dbclass->error;
                  break;
                }
              }
              if($bok)break;
            }
          }else{
            $method=getFromArray($this->permit[$permission],$this->roleID,0);
            if($method==1000){
              $bok=$this->bcheckMaster($this->postfields[$this->masterkey],'update',$this->roleID);
            }else{
              $arr=array("method"=>$method,"table"=>$this->table,"clause"=>$clause);
              If($this->dbclass->bRecordAccess($arr)){
                $bok=1;
              }else{
                $this->error=$this->dbclass->error;
              }
            }
          }
        }
        if($bok){
          //echo "<pre>";
          //print_r($this->postfields);
          //echo "</pre>";
          $this->sql='UPDATE ' . $this->table . ' SET ';
          $this->sql.=$this->dbclass->buildSqlUpdateFromInput($this->colobject,$this->postfields)
                  .' WHERE '.$clause;   //clientID='.$this->clientID
          //echo "sql=".htmlspecialchars($this->sql).'<br>';
          $result=$this->db->query($this->sql);
          if(!$result){
              $this->error= $this->db->error . " " . $this->db->error;
          }
        }
        return (boolean)$result;   
    }

    public function bexist($ID=0){
        if(gbnull($ID))return 0;
        //echo '$clause='.$clause.'<br>';
        $clause=$this->key.'='.$ID;
        return (boolean)$this->dbclass->bexist($this->table,$clause);
    }
    
    public function bload($ID){
        $result=0;
        $data=$this->getentries($this->table.'.'.$this->key.'='.$ID);
        if(count($data)==0){
            if(gbnull($this->error)){
              $this->error='record not found';
            }
        }else{
            $result=1;
        }
        return (boolean) $result;
    }

    public function getEntries($clause,$orderby='') {  // /*datadefID*/
        // ATTENTION RETURN VALUE FALSE WHEN recourdcount=0
        Global $datadefinitions;
        Global $gdatareadlimit;
        $this->data=array();
        $this->dat=array();
        $select='';
        $from='';
        //$rightuser_create=1;//gRightObject($this->rights,'create');

        if($this->rightcheck==1){
          //echo '$this->masterdatadefID='.$this->masterdatadefID.'<br>';
          //if(!gbnull($this->masterdatadefID)){
            // check masterrights
            /*
            if(!is_object($this->omaster)){
              if(gbnull($this->masterdatadefID)){
                $this->error='master object not set!<br>';
              }else{
                $this->omaster=new $datadefinitions[$this->masterdatadefID]['objectclass']($datadefinitions[$this->masterdatadefID]);
              }
            }
            $method=getFromArray($this->omaster->permit['read'],$this->roleID,0);
            //$arr=array("method"=>$method,"table"=>$this->omaster->table,!!!"clause"=>$clause);
            $this->dbclass->bRecordReadPermission($arr,$out);
            //echo '$out[clause]'.$out['clause'].'<br>';
            $clause=gsclauseand($clause,$out['clause'],!gbnull($out['clause']));
            $join=gsclauseand($join,$out['clause'],!gbnull($out['join']));
            */
          //}else{
            
            
            if(0){echo 'count='.count($this->roles).'<br>'; echo "<pre>";print_r($this->permit);echo "</pre>";}
            if(count($this->roles)>0){
              $clause_or='';
              $update_or='';
              $delete_or='';
              
              //echo '<pre>';
              //print_r($datadefinitions);
              //echo '</pre>';
              //echo '$this->masterdatadefID='.$this->masterdatadefID.'<br>';
              
              if(!gbnull($this->masterdatadefID)){
                foreach($this->roles as $roleID){
                  if(isset($datadefinitions[$this->masterdatadefID]['masterdata']['rights']['read'][$roleID])){

                    //if($this->table=='k8loginfriends'){
                    //  $clause=gsclauseand($clause,$this->table.'.userID='.getFromArray($_SESSION,'userID',0));
                    //  $select=gsclauseand($select,'1 as rightuser_update, 1 as rightuser_delete',true,',');
                    //}
                    
                    $method=$datadefinitions[$this->masterdatadefID]['masterdata']['rights']['read'][$roleID];
                    $arr=array("method"=>$method,"table"=>$datadefinitions[$this->masterdatadefID]['table']);
                    //echo $roleID.'/'.$method.'<br>';
                    $this->dbclass->bRecordReadPermission($arr,$out);
                    //echo '$out[clause]'.$out['clause'].'<br>';
                    $clause_or=gsclauseand($clause_or,$out['clause'],!gbnull($out['clause']),' or ');
                    if(getfromarray($this->datadefinition['masterdata'],'sql_addmaster',true)){
                      $from=" INNER JOIN ".$datadefinitions[$this->masterdatadefID]['table'].' ON '.
                        $datadefinitions[$this->masterdatadefID]['table'].'.'.$datadefinitions[$this->masterdatadefID]['key'].'='.$this->table.'.'.$this->masterkey;
                    }
                  }else{
                    //echo 'not set<br>';
                  }
                }
              }          
              foreach($this->roles as $roleID){
                if(isset($this->permit['read'])){
                  $method=getFromArray($this->permit['read'],$roleID,0);
                  $arr=array("method"=>$method,"table"=>$this->table);
                  //echo $roleID.'/'.$method.'<br>';
                  $this->dbclass->bRecordReadPermission($arr,$out);
                  //echo '$out[clause]'.$out['clause'].'<br>';
                  $clause_or=gsclauseand($clause_or,$out['clause'],!gbnull($out['clause']),' or ');
                }else{
                  $clause_or="1=2";
                }
                
                if(isset($this->permit['update'])){
                  //echo $roleID.'/'.getFromArray($this->permit['update'],$roleID,0).'<br>';
                  $arr=array("method"=>getFromArray($this->permit['update'],$roleID,0),"table"=>$this->table,"access"=>"update");
                  $this->dbclass->bRecordUDPermission($arr,$out);
                  $update_or=gsclauseand($update_or,$out['select'],!gbnull($out['select']),' or ');
                }
                
                if(isset($this->permit['delete'])){
                  $arr=array("method"=>getFromArray($this->permit['delete'],$roleID,0),"table"=>$this->table,"access"=>"delete");
                  $this->dbclass->bRecordUDPermission($arr,$out);
                  $delete_or=gsclauseand($delete_or,$out['select'],!gbnull($out['select']),' or ');
                }                
              }
              $clause=gsclauseand($clause,'('.$clause_or.')',!gbnull($clause_or));
              $select=gsclauseand($select,$update_or.'as rightuser_update',!gbnull($update_or),',');
              $select=gsclauseand($select,$delete_or.'as rightuser_delete',!gbnull($delete_or),',');
            }else{
              if(isset($this->permit['read'])){
                $method=getFromArray($this->permit['read'],$this->roleID,0);
                //$arr=array("method"=>$method,"table"=>$this->table,"clause"=>$clause);
                $arr=array("method"=>$method,"table"=>$this->table);
                $this->dbclass->bRecordReadPermission($arr,$out);
                //echo '$out[clause]'.$out['clause'].'<br>';
                $clause=gsclauseand($clause,$out['clause'],!gbnull($out['clause']));
                //join
              }else{
                $clause="1=2";
              }

              if(isset($this->permit['update'])){
                $arr=array("method"=>getFromArray($this->permit['update'],$this->roleID,0),"table"=>$this->table,"access"=>"update");
                $this->dbclass->bRecordUDPermission($arr,$out);
                $select=gsclauseand($select,$out['select'].'as rightuser_update',!gbnull($out['select']),',');
              }
              if(isset($this->permit['delete'])){
                $arr=array("method"=>getFromArray($this->permit['delete'],$this->roleID,0),"table"=>$this->table,"access"=>"delete");
                $this->dbclass->bRecordUDPermission($arr,$out);
                $select=gsclauseand($select,$out['select'].'as rightuser_delete',!gbnull($out['select']),',');
              }
            }
          //}
        }

        $result = []; 
        if(gbnull($orderby)) $orderby=$this->orderby;
        if(getfromArray($this->datadefinition,'datamode',0)==3){
            $this->sql_base = str_replace('§WHERE', iif(gbnull($clause),'1=1',$clause), getfromArray($this->datadefinition,'statement'));
            //echo "1".'<br>';
        }elseif($this->creatormode==2){
            $this->sql_base = 'SELECT '.$this->table.'.*'.iif(gbnull($select),'',','.$select).
               ', creator.creator as creator_corporateID'.
               ' FROM '.$this->table. 
               iif(gbnull($from),'',$from).
               ' LEFT OUTER JOIN addresses as creator ON '.$this->table.'.creatorID=creator.addressID'.
               ' WHERE 1=1 and ' . gsclauseand($clause,$this->table.'.clientID='.iif($clientID==-1,$this->clientID,$clientID)). 
               iif(gbnull($orderby),'',' ORDER BY '.$orderby);
            //echo "2".'<br>';
        }elseif(!gbnull($this->sql_statement)){
            $this->sql_base = $this->sql_statement;
            $this->sql_base = str_replace('§userID',getFromArray($_SESSION,'userID',0),$this->sql_base);
            $this->sql_base = str_replace('§dateformat',$GLOBALS['sqldateformat'],$this->sql_base);
            if(!gbnull($from))$this->sql_base = str_replace('WHERE 1=1',$from.' WHERE 1=1',$this->sql_base);
            if(!gbnull($clause))$this->sql_base = str_replace('1=1',$clause,$this->sql_base);
            $this->sql_base = str_replace('§select',iif(gbnull($select),'',','.$select),$this->sql_base);
            //echo "3".'<br>';
        }else{
            $clause=gsclauseand('1=1',$clause);
            $this->sql_base = 'SELECT '.$this->table.'.*'.iif(gbnull($select),'',','.$select).
               ' FROM '.$this->table.
               iif(gbnull($from),'',$from).
               ' WHERE '.$clause. 
               iif(gbnull($orderby),'',' ORDER BY '.$orderby);
            //echo "4".'<br>';
        }
        // get sqlstatement from definition
        Global $navigation;
        Global $gdatareadlimit;
        Global $gdatareadlimitpage;
        $recordcount=0;
        $navigation=0;
        if(isset($_REQUEST['mytable_offset'])){
            $navigation=1;
            $this->sql=$this->sql_base." LIMIT ".getfromarray($_REQUEST,'mytable_offset',0).','.getfromarray($_REQUEST,'mytable_limit',$gdatareadlimitpage);
            $recordcount=$this->dbclass->expression('count(*)','('.$this->sql_base.') as d','');
            //echo htmlspecialchars($this->sql_base).'<br>';
            //exit();
        }else{
            $this->sql=$this->sql_base." LIMIT ".$gdatareadlimit;
        }
        if(getFromArray($_REQUEST,'bshowsql'))echo htmlspecialchars($this->sql).'<br>';
        $records=$this->db->query($this->sql);
        if($records){
            //also without data you are here
            $bfirst=1;
            while($record=$records->fetch_array(MYSQLI_ASSOC)){
                if($this->baddimage){
                  // image support
                  $record['image_ID']=0;
                  $record['image_file']='masterdata/pic/nopicture.svg'; //$gpath_rel_upload.'ohnebild.jpg';
                  $record['image_orientation']='landscape';
                  $record['image_aspectracio']=1;
                  $record['image_width']=180;
                  $record['image_height']=180;
                  $record['image_count']=$this->dbclass->expression('count(*)', 'k8references', "basetype=".gsstr2sql($this->table)." and type='image' and baseID=".$record[$this->key]);
                  $record['image_array']=[];
                  if($record['image_count']>0){
                    //$imageID=$this->dbclass->lookup('ID', 'k8references', "basetype=".gsstr2sql($this->table)." and type='image' and baseID=".$record[$this->key],'','sort');
                    $clause="basetype=".gsstr2sql($this->table)." and type='image' and baseID=".$record[$this->key];
                    $sql="SELECT ID as image_ID,concat(path,'/',filename) as image_file, case when width>height then 'landscape' else 'portrait' end as image_orientation, width/height as image_aspectratio, width as image_width, height as image_height from k8references WHERE $clause ORDER BY sort";
                    $data_image=$this->dbclass->getentries($sql);
                    if($data_image){
                      $record['image_array']=$data_image;
                      $record=array_merge($record,$data_image[0]);
                    }
                    /*if(!gbnull($imageID)){
                        $dat_image=$this->bloadimage($imageID);
                        if($dat_image)$record=array_merge($record,$dat_image);
                    }*/
                    
                  }
                }
                
                if(count($this->childs)){
                    foreach($this->childs as $k => $x){
                        $record[$this->childs[$k]['fieldname']]=array();
                        $clause=$this->childs[$k]['o_class']->table.'.'.$this->childs[$k]['o_class']->masterkey.'='.$record[$this->key];
                        //echo '$clause='.$clause.'<br>';
                        $data=$this->childs[$k]['o_class']->getentries($clause);
                        if($data){
                            $record[$this->childs[$k]['fieldname']]=$data;
                        }
                    }
                }
                if($navigation){
                   $record['k8_recordcount']=$recordcount;
                }
                $result[]=$record;
            }
            $this->data=$result;
            if(count($this->data)>0){$this->dat=$this->data[0];}
        }else{
            $this->error=$this->db->errno . " " . $this->db->error;
            if(getFromArray($_REQUEST,'bshowsql')) echo $this->error;
        }
        if(0){
            echo "<pre>";
            print_r($result);
            echo "</pre>";
        }
        return $result;       
    }
    
    public function delete($ID) {
        Global $settings;
        Global $langclass;
        
        if(!is_numeric($ID)){
          $this->error=$ID.' is not numeric!';
          return false;
        }
        $ID=(int)$ID;
        
        $this->error='';
        $result=0;
        $echo=0;
        $bok=0;
        $IDdeleted=0;
        $clause=$this->key.'='.$ID;
        
        // check rights
        if($this->rightcheck==0){
          $bok=1;
        }elseif($this->rightcheck==1){
          $permission="delete";
          if(!isset($this->permit[$permission])){
            // nothing allowed
          }elseif(count($this->roles)>0){
            foreach($this->roles as $roleID){
              $method=getFromArray($this->permit[$permission],$roleID,0);
              //echo '$this->roleID='.$this->roleID.'<br>';
              //echo '$method='.$method.'<br>';
              if($method==1000){
                $masterkey=$this->dbclass->lookup($this->masterkey,$this->table,$clause);
                $bok=$this->bcheckMaster($masterkey,'update',$roleID);
              }else{
                $arr=array("method"=>$method,"table"=>$this->table,"clause"=>$clause);
                If($this->dbclass->bRecordAccess($arr)){
                  $bok=1;
                }else{
                  $this->error=$this->dbclass->error;
                  break;
                }
              }
              if($bok)break;
            }
          }else{
            $method=getFromArray($this->permit[$permission],$this->roleID,0);
            //echo '2, $method='.$method.'<br>';
            if($method==1000){
              //echo $this->masterkey.' / '.$this->table.' / '.$this->key.'='.$ID;
              $masterkeyvalue=$this->dbclass->lookup($this->masterkey,$this->table,$this->key.'='.$ID);
              $bok=$this->bcheckMaster($masterkeyvalue,'update',$this->roleID);
            }else{
              $arr=array("method"=>$method,"table"=>$this->table,"clause"=>$this->key.'='.$ID);
              If($this->dbclass->bRecordAccess($arr)){
                $bok=1;
              }else{
                $this->error=$this->dbclass->error;
              }
            }
          }
        }
        
        
        if($bok){
          //childs
          if(!getfromArray($this->datadefinition['masterdata'],'childs_deletetrigger',0)){
            foreach($this->childs as $index => $child){
                // delete by program
                if(count($this->childs[$index]['o_class']->childs)>0){
                    // read childs of child
                    $clause=gsclauseand('clientID='.$this->clientID, $this->childs[$index]['o_class']->masterkey.'='.$ID);
                    if($echo)echo '$clause='.$clause.'<br>';
                    $data_del=$this->childs[$index]['o_class']->getEntries($clause);
                    if($data_del){
                        foreach($data_del as $dat_del){
                            if($echo)echo 'delete='.$dat_del[$this->childs[$index]['o_class']->key].'<br>';
                            if($this->childs[$index]['o_class']->delete($dat_del[$this->childs[$index]['o_class']->key])){
                                //
                            }else{
                                $this->error.=$this->childs[$index]['o_class']->geterror();
                            }
                        }
                    }
                }else{
                    $sql = 'DELETE FROM '.$this->childs[$index]['o_class']->table . ' WHERE '.$this->childs[$index]['o_class']->masterkey. ' = ?';
                    $stmt = $this->db->prepare($sql);
                    $stmt->bind_param('i', $ID);
                    $stmt->execute();
                    $result = $stmt->affected_rows;
                    if($echo){
                        echo 'Delete='.htmlentities($sql).'<br>';
                        echo '<pre>';
                        print_r($result);
                        echo '<pre>';
                    }
                    $stmt->close();
                }
            }
          }
          
          // ----------- with image support ----------------
          if($this->baddimage){
            Global $datadefinitions;
            if(isset($datadefinitions[8])){
              $o_image=new data_accessclass($datadefinitions[8]);
              $data=$o_image->getentries('basetype='.gsstr2sql($this->table).' and baseID='.$ID);
              if($data){
                foreach($data as $dat){
                  if(!$o_image->delete($dat['ID'])){
                    $this->error.=$o->getError();
                  }
                }
              }
            }else{
              $this->error.='datadefinitions[8] not set!';
            }
          }
          
          if($bok and gbnull($this->error)){
              // check relation in foreign tables
              // foreign keys:
              //    - ...
            
              if(gbnull($this->error)){
                  $path='';
                  $filename='';
                  //echo '$this->table='.$this->table.'<br>';
                  if($this->table=="k8references"){
                    $type=$this->dbclass->lookup("type",$this->table,"ID=".$ID);
                    //echo '$type='.$type.'<br>';
                    if($type=="image"){
                        $path=$this->dbclass->lookup("path",$this->table,"ID=".$ID);
                        $filename=$this->dbclass->lookup("filename",$this->table,"ID=".$ID);
                    }
                  }                
                
                  $this->sql = 'DELETE FROM ' . $this->table . ' WHERE '.$this->key. ' = ?';
                  $stmt = $this->db->prepare($this->sql);
                  $stmt->bind_param('i', $ID);
                  $stmt->execute();
                  $result = $stmt->affected_rows;
                  //echo '<pre>';
                  //print_r($result);
                  //echo '<pre>';
                  $stmt->close();
                  //echo 'Error:'.$this->db->error.'<br>';
                  if($result==0){
                      $this->error=$this->db->errno . " " . $this->db->error;
                  }else{
                      $IDdeleted=$ID;
                  }
                    
                  if($result and $this->table=="k8references" and !gbnull($filename)){
                    //$targetfile=dirname( __FILE__ ).DIRECTORY_SEPARATOR.'../'.$path."/".$filename;
                    $targetfile='../'.$path."/".$filename;
                    //echo "$targetfile=".$targetfile.'<br>';
                    if(file_exists($targetfile)){
                        //echo "delete ".$targetfile.'<br>';
                        unlink($targetfile);
                    }
                  }
              }
          }
        }
        //return (boolean)$result;
        return $IDdeleted;
    }

    function bcheckMaster($master_ID,$permission,$roleID){
      Global $datadefinitions;
      //echo 'bcheckMaster.$master_ID='.$master_ID.'<br>';
      $result=0;
      if(!is_object($this->omaster)){
        if(gbnull($this->masterdatadefID)){
          $this->error='master object not set!<br>';
        }else{
          //$this->omaster=new $datadefinitions[$this->masterdatadefID]['objectclass']($datadefinitions[$this->masterdatadefID]);
          $this->omaster=getDatadefinition($this->masterdatadefID,$master_ID,0,"",1);
        }
      }
      if(is_object($this->omaster)){
        if(isset($this->omaster->permit[$permission])){
          $this->omaster->keyvalue=$master_ID;
          if(gbnull($this->omaster->keyvalue)){
             $this->error='master key missing!<br>';
          }else{
            //check master
            $clause=$this->omaster->key.'='.$this->omaster->keyvalue;
            $method=getFromArray($this->omaster->permit[$permission],$roleID,0);
            $arr=array("method"=>$method,"table"=>$this->omaster->table,"clause"=>$clause);
            if(0){
              echo '$clause='.$clause.'<br>';
              echo '<pre>';
              print_r($this->omaster->permit);
              echo '</pre>';
              echo '$permission='.$permission.'<br>';
              echo '$method='.$method.'<br>';
            }
            If($this->dbclass->bRecordAccess($arr)){
              $result=1;
            }else{
              $this->error=$this->dbclass->error;
            }
          }
        }
      }
      return $result;
    }
    
    public function bPreparePDF($jsonfile,$clause='',$dest='I',&$filename=''){
        //echo 'clause='.$clause."<br>";
        $type=getfromarray($_GET,'type',0);
        $this->output='';
        
        // pdf-Defintion
        $temp=gsread_file(str_repeat('../',$GLOBALS['script_depth']).'masterdata/'.$jsonfile);
        $data_sel=json_decode($temp,true);
        $data_sel=data_sel_extendstructure($data_sel);
        $bload=(count($data_sel)>0);
        
        if($bload){
            if(0){
                echo '<pre>';
                print_r($data_sel);
                //print_r($_SESSION);
                echo '</pre>';
                exit;
            }
            
            //echo '1 test'."<br>";
            //$this->layout=10;
            if($this->getentries($clause)){

                // ------------- filename
                //Global $gpath_rel_client;
                //$filepath=AddorDel($_SERVER['DOCUMENT_ROOT'],'/',0,1).AddorDel(untrailingslashit($gpath_rel_client),'/',1,0);
                //$filepath=untrailingslashit($gpath_rel_client);
                //$filename='/'.$filepath.'/'.$this->dat['docname'].' '.$this->dat['docnumber'].'.pdf';
                //$filename='/'.$filepath.'/'.$this->dat['docname'].' '.$this->dat['docnumber'].'.pdf';
                $filename=$_SERVER['DOCUMENT_ROOT'].'/download/test.pdf';
                //echo '$filename='.$filename.'<br>';
                
                if(0){
                echo '<pre>';
                echo 'data:'.'<br>';
                print_r($this->data);
                echo '</pre>';
                }                
                
                // ---------- sender
                /*
                $addresses=new addresses();
                $clause=$addresses->table.'.addressID='.getfromarray($_SESSION,'corporateID',0);
                if($addresses->getEntries($clause)){
                    $addresses->dat['logo']=$this->dbclass->lookup("Concat(path,'/',filename)",'ref',"title='Logo' and basetype='addresses' and baseID=".getfromarray($_SESSION,'corporateID',0));
                    $dat_adr=gArrayNameAddConst($addresses->dat,'sender.');
                    //echo '<pre>';
                    //print_r($dat_adr);
                    //echo '</pre>';
                    //exit;
                }else{
                    $this->error.='no sender!';
                    return 0;
                }*/
                
                $data=$this->data;
                
                if($data){
                    //if(count($data)==0){
                    //    $this->error='no data';
                    //    return 0;
                    //}
                    require_once "../tcpdf/tcpdf.php";
                    $pdf = new oPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);
                    $bmodel=0;

                    if($bmodel)$pdf->borderdefault=1;     //1 set border
                    //echo '$this->borderdefault='.$this->borderdefault.'<br>';
                    //exit;

                    if(1){
                      $data[0]['pdf.author']='author';
                      $data[0]['pdf.title']='Test';
                      if($pdf->_PrintOut($data_sel,$data,$dest,$filename)){
                          return 1;
                      }else{
                          $this->error=$pdf->error;
                          return 0;
                      }
                    }else{
                        foreach($this->data as $dat){
                            $dat=array_merge($dat,$dat_adr);
                            //$dat['pdf.author']='';
                            //$dat['pdf.title']='';
                            $dat['pdf.author']=$this->dat['doceditor'];
                            $dat['pdf.title']=$this->dat['docname'].' '.$this->dat['docnumber'];
                            $dat['pdf.subject']='';
                            $dat['pdf.keywords']='';
                            $this->data=array();
                            $this->data[]=$dat;

                            //echo '<pre>';
                            //print_r($this->data);
                            //print_r($odatadefinitions->dataselections->data);
                            //echo '</pre>';
                            //exit;
                            if($odatadefinitions->bPrintPDF($this,$this->data,'',$dest,$filename)){

                            }else{
                                $this->error.=$odatadefinitions->getError();
                            }
                        }
                    }
                    
                    
                }else{
                    $this->error='no data';
                    return 0;
                }
            }else{
              if(gbnull($this->getError())){
                  $this->error.='no data';
              }else{
                  $this->error.=$this->getError();
              }
            }
        }else{
          if(gbnull($this->getError())){
              $this->error.='not loaded';
          }else{
              $this->error.=$this->getError();
          }
        }
        return (strlen($this->error)==0);
    }   
    public function bPrintPDF($o,$data,$clause='',$dest='I',$filename="test.pdf",$bmodel=0){

        if(0){
        echo '<pre>';
        //print_r($this->data);
        print_r($this->dataselections->data);
        //print_r($data);
        echo '</pre>';
        exit();
        }
        
        if($data){
            //if(count($data)==0){
            //    $this->error='no data';
            //    return 0;
            //}
            require_once "../tcpdf/tcpdf.php";
            $pdf = new oPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);
            if($bmodel)$pdf->borderdefault=1;     //1 set border
            //echo '$this->borderdefault='.$this->borderdefault.'<br>';
            //exit;
            
            // init PAGE
            // set document (meta) information
            //_PrintOut($o,$datadefinitions,$data,$dest='I',$filename="test.pdf"){
            $data_sel=array();  //!!!!!!!!!
            if($pdf->_PrintOut($data_sel,$data,$dest,$filename)){
                return 1;
            }else{
                $this->error=$pdf->error;
                return 0;
            }
        }else{
            $this->error='no data';
            return 0;
        }
    }
    
}